# This file was auto-generated by Fern from our API Definition.

import enum
import typing

T_Result = typing.TypeVar("T_Result")


class FilesRetrieveRequestExpand(str, enum.Enum):
    DRIVE = "drive"
    FOLDER = "folder"
    FOLDER_DRIVE = "folder,drive"
    PERMISSIONS = "permissions"
    PERMISSIONS_DRIVE = "permissions,drive"
    PERMISSIONS_FOLDER = "permissions,folder"
    PERMISSIONS_FOLDER_DRIVE = "permissions,folder,drive"

    def visit(
        self,
        drive: typing.Callable[[], T_Result],
        folder: typing.Callable[[], T_Result],
        folder_drive: typing.Callable[[], T_Result],
        permissions: typing.Callable[[], T_Result],
        permissions_drive: typing.Callable[[], T_Result],
        permissions_folder: typing.Callable[[], T_Result],
        permissions_folder_drive: typing.Callable[[], T_Result],
    ) -> T_Result:
        if self is FilesRetrieveRequestExpand.DRIVE:
            return drive()
        if self is FilesRetrieveRequestExpand.FOLDER:
            return folder()
        if self is FilesRetrieveRequestExpand.FOLDER_DRIVE:
            return folder_drive()
        if self is FilesRetrieveRequestExpand.PERMISSIONS:
            return permissions()
        if self is FilesRetrieveRequestExpand.PERMISSIONS_DRIVE:
            return permissions_drive()
        if self is FilesRetrieveRequestExpand.PERMISSIONS_FOLDER:
            return permissions_folder()
        if self is FilesRetrieveRequestExpand.PERMISSIONS_FOLDER_DRIVE:
            return permissions_folder_drive()
